export declare type StateAndCallbacksFor<M extends Methods> = [StateFor<M>, CallbacksFor<M>];
export declare type StateFor<M extends Methods> = M extends Methods<infer S, any> ? S : never;
export declare type CallbacksFor<M extends Methods> = M extends Methods<any, infer R> ? {
    [T in ActionUnion<R>['type']]: (...payload: ActionByType<ActionUnion<R>, T>['payload']) => void;
} : never;
export declare type Methods<S = any, R extends MethodRecordBase<S> = any> = (state: S) => R;
export declare type MethodRecordBase<S = any> = Record<string, (...args: any[]) => S extends object ? S | void : S>;
export declare type ActionUnion<R extends MethodRecordBase> = {
    [T in keyof R]: {
        type: T;
        payload: Parameters<R[T]>;
    };
}[keyof R];
export declare type ActionByType<A, T> = A extends {
    type: infer T2;
} ? (T extends T2 ? A : never) : never;
export default function useMethods<S, R extends MethodRecordBase<S>>(methods: Methods<S, R>, initialState: S): StateAndCallbacksFor<typeof methods>;
export default function useMethods<S, R extends MethodRecordBase<S>, I>(methods: Methods<S, R>, initializerArg: I, initializer: (arg: I) => S): StateAndCallbacksFor<typeof methods>;
